                                                                                                                                                                                                                                                                                                                    ##  簡陋
default ang = "Angela"
default b = "Barbara"
default bella = "Bella"
default d = "Daniela"
default don = "Donna"
default e = "Emma"
default cof = "Jane"
default j = "Julia"
default det = "Marcy"
default m = "Mary"
default s = "Sofia"

# label after_load:
#     if renpy.variant("pc") or renpy.variant("web") and not renpy.variant("mobile") and not _in_replay:
#         show screen smcheats

screen smcheats():
    if not _in_replay:
        hbox align(0.5,-0.008):
            textbutton "CHEATS" action If(renpy.get_screen("cheatMenu"), Hide("cheatMenu"), Show("cheatMenu")) text_style "shaddyCheatButton"


init python:
    cheatItems = []

    shownCheatPage = ""

    class CheatItem:
        def __init__(self, category):
            self.category = category
            self.cheats = []
            self.settings = dict()
            if self not in cheatItems:
                cheatItems.append(self)

        def addCheat(self, name, variable, kind="Slider", minValue=0, maxValue=0, trueValue=True, falseValue=False):
            if kind == "Slider":
                rv = [name, variable, kind, minValue, maxValue]
            elif kind == "Button":
                rv = [name, variable, kind, trueValue, falseValue]
            else:
                raise Exception("Unsupported Cheat Type")

            self.cheats.append(rv)

        def addSetting(self, setting, value):
            self.settings[setting] = value

        def maxAll(self):
            for cheat in self.cheats:
                if cheat[2] == "Slider":
                    setattr(store, cheat[1], cheat[4])

    MC = CheatItem("[y]'s Stats")
    RelationPts = CheatItem("Relation Points")
    RelationStatus = CheatItem("Relation Status")

    MC.addCheat("Leader Points", "main_leader", maxValue=50)
    MC.addCheat("Ruthless Points", "main_ruthless", maxValue=50)

    RelationPts.addCheat("[ang]", "angela_relation_meter", maxValue=50)
    RelationPts.addCheat("[b]", "barbara_relation_meter", maxValue=50)
    RelationPts.addCheat("[bella]", "bella_relation_meter", maxValue=50)
    RelationPts.addCheat("[d]", "daniela_relation_meter", maxValue=50)
    RelationPts.addCheat("[don]", "donna_relation_meter", maxValue=50)
    RelationPts.addCheat("[e]", "elena_relation_meter", maxValue=50)
    RelationPts.addCheat("[cof]", "jane_relation_meter", maxValue=50)
    RelationPts.addCheat("[j]", "julia_relation_meter", maxValue=50)
    RelationPts.addCheat("[det]", "marcy_relation_meter", maxValue=50)
    RelationPts.addCheat("[m]", "mary_relation_meter", maxValue=50)
    RelationPts.addCheat("[s]", "sofia_relation_meter", maxValue=50)

    RelationStatus.addCheat("[ang]", "angela_relation", maxValue=2)
    RelationStatus.addCheat("[b]", "barbara_relation", maxValue=2)
    RelationStatus.addCheat("[bella]", "bella_relation", maxValue=2)
    RelationStatus.addCheat("[d]", "daniela_relation", maxValue=2)
    RelationStatus.addCheat("[don]", "donna_relation", maxValue=2)
    RelationStatus.addCheat("[e]", "elena_relation", maxValue=2)
    RelationStatus.addCheat("[cof]", "jane_relation", maxValue=2)
    RelationStatus.addCheat("[j]", "julia_relation", maxValue=2)
    RelationStatus.addCheat("[det]", "marcy_relation", maxValue=2)
    RelationStatus.addCheat("[m]", "mary_relation", maxValue=2)
    RelationStatus.addCheat("[s]", "sofia_relation", maxValue=2)

    MC.addSetting("cols", 2)
    MC.addSetting("xspacing", 100)
    MC.addSetting("yspacing", 10)

    RelationPts.addSetting("cols", 3)
    RelationPts.addSetting("xspacing", 100)
    RelationPts.addSetting("yspacing", 10)

    RelationStatus.addSetting("cols", 3)
    RelationStatus.addSetting("xspacing", 100)
    RelationStatus.addSetting("yspacing", 10)

default shownCheatPage = ""

screen cheatMenu():
    tag menu
    modal True
    zorder 100

    frame:
        background Solid("#0ed6f97F")
        align (0.5,0.5)
        xysize (1370,770)
        fixed:
            add "#000"
            add Transform("shaddyMod/images/ShaddyBG2.png", zoom=0.97) alpha 0.65 xalign 0.5 yalign 0.5

            hbox:
                xcenter 0.5
                ycenter 30
                spacing 15
                hbox:
                    spacing -5
                    text "S" at delayed_blink(1.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "h" at delayed_blink(0.9, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "a" at delayed_blink(0.8, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "d" at delayed_blink(0.7, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "d" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "y" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "M" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "o" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "d" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "d" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "a" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "'" at delayed_blink(0.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "s" at delayed_blink(0.1, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                hbox:
                    spacing -5
                    text "C" at delayed_blink(0.2, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "h" at delayed_blink(0.3, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "e" at delayed_blink(0.4, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "a" at delayed_blink(0.5, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "t" at delayed_blink(0.6, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                hbox:
                    spacing -5
                    text "M" at delayed_blink(0.7, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "e" at delayed_blink(0.8, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "n" at delayed_blink(0.9, 2.0) outlines [(3, "#000")] style "shaddyHeader"
                    text "u" at delayed_blink(1.0, 2.0) outlines [(3, "#000")] style "shaddyHeader"

            #text "ShaddyModda's Cheat Menu" xcenter 0.5 ycenter 40 style "shaddyHeader"

            default shownCheatMenu = None

            vpgrid:
                rows 1
                xcenter 0.5
                ycenter 0.115
                spacing 75
                hbox:
                    ycenter 0.5
                    spacing 20
                    for i in cheatItems:
                        textbutton i.category:
                            text_style "shaddyTextButtonHeader"
                            action [Function(renpy.retain_after_load), SetScreenVariable("shownCheatMenu", value=i), SetVariable("shownCheatPage", i.category)]
                            #action [Function(renpy.retain_after_load), SetVariable("shownCheatMenu", i.category)]

        for i in cheatItems:
            if shownCheatMenu == i:
                use cheatMenuValues(cheatMenuChar=i)
        if shownCheatPage == "Relation Status":
            text "0 = Dislike     1 = Friendly     2 = Intimate" style "shaddyBody1" xcenter 0.5 ycenter 0.275


        textbutton "CLOSE" action Hide("cheatMenu"), Return() align(0.998,0.002) text_style "shaddyTextButton1"

        vbox:
            align(0.998,0.998)
            xysize(175,150)
            imagebutton:
                idle im.Scale("shaddyMod/images/patreon.png", 150, 40)
                hover im.Scale(im.MatrixColor("shaddyMod/images/patreon.png", im.matrix.colorize("#cc33cc", "#009dff")), 175, 50)
                action OpenURL("https://www.patreon.com/ShaddyModda")
            imagebutton:
                idle im.Scale("shaddyMod/images/substar.png", 150, 40)
                hover im.Scale(im.MatrixColor("shaddyMod/images/substar.png", im.matrix.colorize("#cc33cc", "#009dff")), 175, 50)
                action OpenURL("https://subscribestar.adult/shaddymodda")
            imagebutton:
                idle im.Scale("shaddyMod/images/Discord.png", 150, 40)
                hover im.Scale(im.MatrixColor("shaddyMod/images/Discord.png", im.matrix.colorize("#f00", "#f00")), 175, 50)
                action OpenURL("https://discord.gg/qqdNVrtJWF")


screen cheatMenuValues(cheatMenuChar):
    tag cheatmenu
    zorder 199

    vbox:
        xalign 0.5
        ypos 240

        vpgrid:
            cols cheatMenuChar.settings["cols"]
            xspacing cheatMenuChar.settings["xspacing"]
            yspacing cheatMenuChar.settings["yspacing"]
            for x in cheatMenuChar.cheats:
                if x[2] == "Slider":
                    frame:
                        xysize(320, 100)
                        background Solid("#0000BF7F")
                        vbox:
                            spacing 10
                            text "{}:".format(x[0]) xcenter 0.5 style "shaddyBody1"
                            hbox:
                                #align(0.5,0.5)
                                spacing 3
                                fixed:
                                    xysize (250, 39)
                                    bar value VariableValue(x[1], x[4]-x[3], offset=x[3])
                                    text "{}".format(getattr(store, x[1])) style "shaddyTextBody2" xcenter 0.5 ycenter 0.4
                                textbutton "MAX" action SetVariable(x[1], x[4]) text_style "shaddyTextButton1" ypos -0.2

                if [x for x in cheatMenuChar.cheats if x[2] == "Button"]:
                    vpgrid:
                        cols cheatMenuChar.settings["cols"]
                        xspacing cheatMenuChar.settings["xspacing"]
                        yspacing cheatMenuChar.settings["yspacing"]
                        for x in cheatMenuChar.cheats:
                            if x[2] == "Button":
                                frame:
                                    #xysize(340, 110)
                                    background Solid("#0000BF7F")
                                    hbox:
                                        textbutton "[x[0]]" action ToggleVariable(x[1], true_value=x[3], false_value=x[4]) xcenter 0.5 ycenter 0.5 text_style "shaddyTextButton1"
                                        text "[x[1]]" xcenter 0.5 ycenter 0.5 style "shaddyBody1"

    if shownCheatPage != "[y]'s Stats":
        textbutton "MAX ALL":
            text_style "shaddyTextButton1"
            align(0.5, 1.0)
            action Function(cheatMenuChar.maxAll)
