screen gallerymod():
    tag menu
    add "bg_giveto.jpg"
    text "Gallery Mod" style "slheading"
    text "Credit to Sir Leon for initial layout" align(0.5,1.0) style "slnote"

    vpgrid:
        cols 4
        xalign 0.5
        yalign 0.3
        xspacing 100

        imagebutton:
            idle "boardm_idle.png"
            hover "boardm_hover.png"
            action ShowMenu("gallerymodmary")
        imagebutton:
            idle "boarddan_idle.png"
            hover "boarddan_hover.png"
            action ShowMenu("gallerymoddan")
        imagebutton:
            idle "boardbella_idle.png"
            hover "boardbella_hover.png"
            action ShowMenu("gallerymodbella")
        imagebutton:
            idle "boardjane_idle.png"
            hover "boardjane_hover.png"
            action ShowMenu("gallerymodjane")
        imagebutton:
            idle "boards_idle.png"
            hover "boards_hover.png"
            action ShowMenu("gallerymodsofia")
        imagebutton:
            idle "boardb_idle.png"
            hover "boardb_hover.png"
            action ShowMenu("gallerymodbarbara")
        imagebutton:
            idle "boardang_idle.png"
            hover "boardang_hover.png"
            action ShowMenu("gallerymodangela")
        imagebutton:
            idle "boardj_idle.png"
            hover "boardj_hover.png"
            action ShowMenu("gallerymodjulia")
    vpgrid:
        cols 3
        xalign 0.5
        yalign 0.95
        xspacing 100
        imagebutton:
            idle "boardcop_idle.png"
            hover "boardcop_hover.png"
            action ShowMenu("gallerymodmarcy")
        imagebutton:
            idle "boarddonna_idle.png"
            hover "boarddonna_hover.png"
            action ShowMenu("gallerymoddonna")
        imagebutton:
            idle "boardel_idle.png"
            hover "boardel_hover.png"
            action ShowMenu("gallerymodele")


    textbutton "Return" xalign 0.01 yalign 0.99 action Return()

    imagebutton:
        xalign 0.99 yalign 0.87
        idle im.Scale("shaddyMod/images/patreon.png", 100, 35)
        hover im.Scale(im.MatrixColor("shaddyMod/images/patreon.png", im.matrix.colorize("#cc33cc", "#009dff")), 120, 45)
        action OpenURL("https://www.patreon.com/ShaddyModda")
    imagebutton:
        xalign 0.99 yalign 0.93
        idle im.Scale("shaddyMod/images/substar.png", 100, 35)
        hover im.Scale(im.MatrixColor("shaddyMod/images/substar.png", im.matrix.colorize("#cc33cc", "#009dff")), 120, 45)
        action OpenURL("https://subscribestar.adult/shaddymodda")
    imagebutton:
        xalign 0.99 yalign 0.99
        idle im.Scale("shaddyMod/images/Discord.png", 100, 35)
        hover im.Scale(im.MatrixColor("shaddyMod/images/Discord.png", im.matrix.colorize("#f00", "#f00")), 120, 45)
        action OpenURL("https://discord.gg/qqdNVrtJWF")


style slheading:
    font "shaddyMod/slheading.ttf"
    xalign 0.5
    size 70
style slheading2:
    font "shaddyMod/slheading.ttf"
    xalign 0.5
    size 50
    yalign 0.12
style slnote:
    font "shaddyMod/slheading.ttf"
    size 30



screen gallerymoddan():
    tag menu
    add "bg_biodaniela.jpg"
    text "Daniela Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaydaniela01_%s.png" focus_mask True action Replay("replay_v1_home_daniela", locked=False)
        imagebutton auto "replaythreesome01_%s.png" focus_mask True action Replay("replay_v3_threesome_daniela", locked=False)
        imagebutton auto "replaydaniela02_%s.png" focus_mask True action Replay("replay_v6_barsex_daniela", locked=False)
        imagebutton auto "replaydonna03_%s.png" focus_mask True action Replay("replay_v7_dand_thresome", locked=False)

    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymoddan"), ShowMenu("gallerymod")

screen gallerymodbella():
    tag menu
    add "bg_biobella.jpg"
    text "Bella Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaybella01_%s.png" focus_mask True action Replay("replay_v5_bella_sex", locked=False)
        imagebutton auto "replaybella02_%s.png" focus_mask True action Replay("replay_v6_bella_sex", locked=False)
        imagebutton auto "replaybella03_%s.png" focus_mask True action Replay("replay_v10_bella_sex", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodbella"), ShowMenu("gallerymod")

screen gallerymodjane():
    tag menu
    add "bg_biojane.jpg"
    text "Jane Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replayjane01_%s.png" focus_mask True action Replay("replay_v1_appartment_jane", locked=False)
        imagebutton auto "replayjane02_%s.png" focus_mask True action Replay("replay_v2_home_jane", locked=False)
        imagebutton auto "replayjane03_%s.png" focus_mask True action Replay("replay_v3_appartment_jane", locked=False)
        imagebutton auto "replaythreesome01_%s.png" focus_mask True action Replay("replay_v3_threesome_jane", locked=False)

    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodjane"), ShowMenu("gallerymod")

screen gallerymodsofia():
    tag menu
    add "bg_biosofia.jpg"
    text "Sofia Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaysofia01_%s.png" focus_mask True action Replay("replay_v3_peep01_sofia", locked=False)
        imagebutton auto "replaysofia02_%s.png" focus_mask True action Replay("replay_v3_peep02_sofia", locked=False)
        imagebutton auto "replaysofia03_%s.png" focus_mask True action Replay("v10_sofia_sex", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodsofia"), ShowMenu("gallerymod")

screen gallerymodbarbara():
    tag menu
    add "bg_biobarbara.jpg"
    text "Barbara Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaybarbara01_%s.png" focus_mask True action Replay("replay_v2_peep_barbara", locked=False)
        imagebutton auto "replaybarbara02_%s.png" focus_mask True action Replay("replay_v4_barbara02", locked=False)
        imagebutton auto "replaybarbara03_%s.png" focus_mask True action Replay("replay_v7_barbara_sex", locked=False)
        imagebutton auto "replaybarbara04_%s.png" focus_mask True action Replay("replay_v9_barbara_sex", locked=False)
        imagebutton auto "replaybandm01_%s.png" focus_mask True action Replay("replay_v9_bandm_sex", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodbarbara"), ShowMenu("gallerymod")

screen gallerymodangela():
    tag menu
    add "bg_bioangela.jpg"
    text "Angela Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replayangela01_%s.png" focus_mask True action Replay("replay_v1_appartment_angela", locked=False)
        imagebutton auto "replayangela02_%s.png" focus_mask True action Replay("replay_v3_appartment_angela", locked=False)
        imagebutton auto "replayangela03_%s.png" focus_mask True action Replay("replay_v5_anal_angela", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodangela"), ShowMenu("gallerymod")

screen gallerymodjulia():
    tag menu
    add "bg_biojulia.jpg"
    text "Julia Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replayjulia01_%s.png" focus_mask True action Replay("replay_v3_peep_julia", locked=False)
        imagebutton auto "replayjulia02_%s.png" focus_mask True action Replay("replay_v6_peep_julia", locked=False)
        imagebutton auto "replayjulia03_%s.png" focus_mask True action Replay("replay_v6_bj_julia", locked=False)
        imagebutton auto "replayjulia04_%s.png" focus_mask True action Replay("replay_v9_julia_sex", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodjulia"), ShowMenu("gallerymod")

screen gallerymodmary():
    tag menu
    add "bg_biomary.jpg"
    text "Mary Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaymary01_%s.png" focus_mask True action Replay("replay_v2_home_mary", locked=False)
        imagebutton auto "replaymary02_%s.png" focus_mask True action Replay("replay_v3_peep_mary", locked=False)
        imagebutton auto "replaymary03_%s.png" focus_mask True action Replay("replay_v5_peep_mary", locked=False)
        imagebutton auto "replaymary04_%s.png" focus_mask True action Replay("replay_v6_hospital_mary", locked=False)
        imagebutton auto "replaymary05_%s.png" focus_mask True action Replay("replay_v6_room_mary", locked=False)
        imagebutton auto "replaymary06_%s.png" focus_mask True action Replay("replay_v8_mary_sex", locked=False)
        imagebutton auto "replaybandm01_%s.png" focus_mask True action Replay("replay_v9_bandm_sex", locked=False)

    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodmary"), ShowMenu("gallerymod")

screen gallerymodmarcy():
    tag menu
    add "bg_biomarcy.jpg"
    text "Marcy Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaymarcy01_%s.png" focus_mask True action Replay("replay_v4_marcy_sex", locked=False)
        imagebutton auto "replaymarcy02_%s.png" focus_mask True action Replay("replay_v8_marcy_sex", locked=False)

    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodmarcy"), ShowMenu("gallerymod")

screen gallerymoddonna():
    tag menu
    add "bg_biodonna.jpg"
    text "Donna Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replaydonna01_%s.png" focus_mask True action Replay("replay_v4_donna_bj", locked=False)
        imagebutton auto "replaydonna02_%s.png" focus_mask True action Replay("replay_v5_donna_sex", locked=False)
        imagebutton auto "replaydonna03_%s.png" focus_mask True action Replay("replay_v7_dand_thresome", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymoddonna"), ShowMenu("gallerymod")

screen gallerymodele():
    tag menu
    add "bg_bioelena.jpg"
    text "Elena Replay Gallery" style "slheading2"
    vpgrid:
        cols 3
        xpos 460
        ypos 300
        xspacing 50
        yspacing 15
        imagebutton auto "replayelena01_%s.png" focus_mask True action Replay("replay_v7_elena_bj", locked=False)
        imagebutton auto "replayelena02_%s.png" focus_mask True action Replay("replay_v9_elena_sex", locked=False)


    textbutton "Return" xalign 0.01 yalign 0.99 action Hide("gallerymodele"), ShowMenu("gallerymod")
