
default persistent.unlocked = True

init python:
    def clear_bio_screens():
        screen_list_bio_board = [
            "bio_back","bio_reset","bio_character_name","bio_replay_text","bio_ang_details_001","bio_cop_details_001","bio_donna_details_001","bio_b_details_001","bio_j_details_001","bio_cof_details_001",
            "bio_y_details_001", "bio_p_details_001", "bio_m_details_001", "bio_f_details_001", "bio_d_details_001", "bio_s_details_001", "bio_sal_details_001","bio_bella_details_001", "bio_donf_details_001",
            "mymoney","bio_character_points","bio_character_status","bio_character_ruthless","bio_character_leader","bio_e_details_001", "fullhistory",
            ]

        for s in screen_list_bio_board:
            renpy.hide_screen(s)

    def clear_front_screens():
        screen_list_front_board = [
            "board_continue","board_donf","board_bella","board_control","board_control34","board_shop","board_donna","board_marcy","board_main","board_ang","board_jane","board_newmale","board_newfemale",
            "board_paulie","board_mary", "board_frank", "board_sofia", "board_daniela", "board_julia", "board_barbara","board_sal","mymoney", "allhistory", "bio_back_history", "fullhistory",
            "board_control631", "board_control622", "board_control532", "board_control343", "board_control712", "board_control523", "board_elena", "board_elena2", "board_control442", "board_control352", "board_control262",
            "board_control550"
            ]

        for s in screen_list_front_board:
            renpy.hide_screen(s)

    def clear_replay_screens():
        screen_list_replay = [
            "replay_jane_01","replay_jane_02","replay_01_lock","replay_02_lock","replay_daniela_01","replay_barbara_01", "replay_mary_01","replay_angela_01","replay_angela_02","replay_angela_03","replay_barbara_01","replay_mary_01","replay_sofia_01","replay_sofia_02","replay_mary_02",
            "replay_julia_01","replay_03_lock","replay_jane_03","replay_threesome_j_01","replay_threesome_d_01","bio_donna_details_001","replay_04_lock","bio_character_points","bio_character_status",
            "bio_ang_details_001","bio_b_details_001","bio_m_details_001","bio_bella_details_001","bio_cof_details_001","bio_d_details_001","bio_s_details_001","bio_j_details_001","bio_cop_details_001",
            "bio_reset","bio_character_name","bio_replay_text","bio_back", "replay_barbara_02", "replay_marcy_01","replay_donna_01","replay_donna_02","replay_bella_01","replay_mary_03", "replay_mary_04", "replay_daniela_02",
            "replay_bella_02", "replay_mary_05","replay_julia_02","replay_julia_03", "replay_05_lock", "replay_donna_03", "replay_daniela_04", "replay_barbara_03", "replay_barbara_03", "bio_e_details_001",
            "replay_elena_01", "fullhistory", "replay_marcy_02", "replay_mary_06", "replay_06_lock", "replay_07_lock", "replay_elena_02", "replay_barbara_04", "replay_julia_04", "replay_bandm_b_01", "replay_bandm_m_01", "replay_sofia_03", "replay_bella_03"
            ]

        for s in screen_list_replay:
            renpy.hide_screen(s)

    def clear_store_screens():
        screen_list_front_board = [
            "buylingerie", "buybook","buywallmark","youhavemoney","bio_back","givemary","givesofia","givedaniela","givejulia","givejane","givebarbara","giveangela","givebella","givemarcy","givedonna","givelockangela",
            "givelockmarcy","givelockbarbara","givelockjane", "givelockdonna", "buyjewel"
            ]

        for s in screen_list_front_board:
            renpy.hide_screen(s)

    def set_relationship_status(status):
        statuslist = ["Dislike","Friendly","Intimate"]
        return statuslist[status]

define relationship_status = "N/A"
define relationship_points = 0

### BOARD SCREENS

screen city_control_meter:
    hbox:
        xpos 100
        ypos 10
        text "G = [city_control_g] T = [city_control_t] F = [city_control_f]"

screen mymoney:
    hbox:
        xpos 530
        ypos 628
        text "[textmoneyblack]MONEY: [money]$"

screen gotostroyboard:
    hbox:
        xpos 1085
        ypos 670
        imagebutton auto "gotoboard_%s.png" focus_mask True action Jump("storyboard")

screen board_continue:
    hbox:
        xpos 1175
        ypos 585
        imagebutton auto "boardcont_%s.png" focus_mask True action Jump("story_continues")

screen board_control:
    hbox:
        xpos 1133
        ypos 15
        image "board_control.png"

screen board_control34:
    hbox:
        xpos 1133
        ypos 15
        image "board_control_34.png"

screen board_control631:
    hbox:
        xpos 1133
        ypos 15
        image "board_control631.png"

screen board_control532:
    hbox:
        xpos 1133
        ypos 15
        image "board_control532.png"

screen board_control622:
    hbox:
        xpos 1133
        ypos 15
        image "board_control622.png"

screen board_control712:
    hbox:
        xpos 1133
        ypos 15
        image "board_control712.png"

screen board_control343:
    hbox:
        xpos 1133
        ypos 15
        image "board_control343.png"

screen board_control523:
    hbox:
        xpos 1133
        ypos 15
        image "board_control523.png"

screen board_control442:
    hbox:
        xpos 1133
        ypos 15
        image "board_control442.png"

screen board_control352:
    hbox:
        xpos 1133
        ypos 15
        image "board_control352.png"

screen board_control262:
    hbox:
        xpos 1133
        ypos 15
        image "board_control262.png"

screen board_control550:
    hbox:
        xpos 1133
        ypos 15
        image "board_control550.png"

screen board_shop:
    hbox:
        xpos 1210
        ypos 460
        imagebutton auto "shopicon_%s.png" focus_mask True action Jump("onlinestore")

screen board_main:
    hbox:
        xpos 15
        ypos 15
        imagebutton auto "boardmain_%s.png" focus_mask True action Jump("bio_main")

screen board_ang:
    hbox:
        xpos 525
        ypos 305
        imagebutton auto "boardang_%s.png" focus_mask True action Jump("bio_ang")

screen board_jane:
    hbox:
        xpos 575
        ypos 515
        imagebutton auto "boardjane_%s.png" focus_mask True action Jump("bio_cof")

screen board_newmale:
    hbox:
        xpos 1125
        ypos 195
        imagebutton auto "boardnewmale_%s.png" focus_mask True action Jump("bio_newchar")

screen board_newfemale:
    hbox:
        xpos 1125
        ypos 195
        imagebutton auto "boardnewfemale_%s.png" focus_mask True action Jump("bio_newchar")

screen board_paulie:
    hbox:
        xpos 720
        ypos 45
        imagebutton auto "boardp_%s.png" focus_mask True action Jump("bio_paulie")

screen board_mary:
    hbox:
        xpos 110
        ypos 300
        imagebutton auto "boardm_%s.png" focus_mask True action Jump("bio_mary")

screen board_frank:
    hbox:
        xpos 260
        ypos 70
        imagebutton auto "boardf_%s.png" focus_mask True action Jump("bio_frank")

screen board_sofia:
    hbox:
        xpos 30
        ypos 505
        imagebutton auto "boards_%s.png" focus_mask True action Jump("bio_sofia")

screen board_daniela:
    hbox:
        xpos 735
        ypos 255
        imagebutton auto "boarddan_%s.png" focus_mask True action Jump("bio_daniela")

screen board_julia:
    hbox:
        xpos 915
        ypos 255
        imagebutton auto "boardj_%s.png" focus_mask True action Jump("bio_julia")

screen board_barbara:
    hbox:
        xpos 940
        ypos 45
        imagebutton auto "boardb_%s.png" focus_mask True action Jump("bio_barbara")

screen board_donna:
    hbox:
        xpos 775
        ypos 535
        imagebutton auto "boarddonna_%s.png" focus_mask True action Jump("bio_donna")

screen board_marcy:
    hbox:
        xpos 964
        ypos 475
        imagebutton auto "boardcop_%s.png" focus_mask True action Jump("bio_marcy")

screen board_sal:
    hbox:
        xpos 515
        ypos 55
        imagebutton auto "boardsal_%s.png" focus_mask True action Jump("bio_sal")

screen board_donf:
    hbox:
        xpos 220
        ypos 530
        imagebutton auto "boarddonf_%s.png" focus_mask True action Jump("bio_donf")

screen board_bella:
    hbox:
        xpos 400
        ypos 490
        imagebutton auto "boardbella_%s.png" focus_mask True action Jump("bio_bella")

screen board_elena:
    hbox:
        xpos 350
        ypos 270
        imagebutton auto "boardel_%s.png" focus_mask True action Jump("bio_elena")

screen board_elena2:
    hbox:
        xpos 350
        ypos 270
        imagebutton auto "boardel2_%s.png" focus_mask True action Jump("bio_elena")

##### BIO SCREENS
screen bio_back:
    hbox:
        xpos 1275
        ypos 667
        imagebutton auto "bioback_%s.png" focus_mask True action Jump("storyboard")

screen bio_back_history:
    hbox:
        xpos 1230
        ypos 615
        imagebutton auto "bioback_%s.png" focus_mask True action Jump("storyboard")

screen bio_reset:
    hbox:
        xpos 1160
        ypos 653
        imagebutton auto "bioreset_%s.png" focus_mask True action Jump("reset_character")

screen bio_replay_text:
    hbox:
        xpos 1020
        ypos 175
        xmaximum 600
        box_wrap True
        text "[txtreplay]REPLAY[endtxtreplay]"

screen bio_character_name:
    hbox:
        xpos 320
        ypos 85
        xmaximum 600
        box_wrap True
        text "[txtbioname][character_bio][endtxtbioname]"

screen bio_character_status:
    hbox:
        xpos 640
        ypos 90
        xmaximum 600
        box_wrap True
        text "[txtsm]Relationship Status: [relationship_status][endtxtsm]"

screen bio_character_points:
    hbox:
        xpos 640
        ypos 120
        xmaximum 600
        box_wrap True
        text "[txtsm]Relation Points: [relationship_points][endtxtsm]"


screen bio_character_leader:
    hbox:
        xpos 640
        ypos 90
        xmaximum 600
        box_wrap True
        text "[txtsm]Leader points: [main_leader][endtxtsm]"

screen bio_character_ruthless:
    hbox:
        xpos 640
        ypos 120
        xmaximum 600
        box_wrap True
        text "[txtsm]Ruthless Points: [main_ruthless][endtxtsm]"

screen fullhistory:
    hbox:
        xpos 1050
        ypos 653
        imagebutton auto "gotohistory_%s.png" focus_mask True action Jump("historical")


### REPLAY SCREENS
screen replay_jane_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replayjane01_%s.png" focus_mask True action Jump("replay_v1_appartment_jane")

screen replay_angela_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replayangela01_%s.png" focus_mask True action Jump("replay_v1_appartment_angela")

screen replay_01_lock:
    hbox:
        xpos 960
        ypos 230
        image "locked_scene.png"


screen replay_02_lock:
    hbox:
        xpos 1050
        ypos 230
        image "locked_scene.png"

screen replay_03_lock:
    hbox:
        xpos 1140
        ypos 230
        image "locked_scene.png"

screen replay_04_lock:
    hbox:
        xpos 960
        ypos 320
        image "locked_scene.png"

screen replay_05_lock:
    hbox:
        xpos 1050
        ypos 320
        image "locked_scene.png"

screen replay_06_lock:
    hbox:
        xpos 1140
        ypos 320
        image "locked_scene.png"

screen replay_07_lock:
    hbox:
        xpos 960
        ypos 410
        image "locked_scene.png"

screen replay_daniela_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaydaniela01_%s.png" focus_mask True action Jump("replay_v1_home_daniela")

screen replay_daniela_02:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaydaniela02_%s.png" focus_mask True action Jump("replay_v6_barsex_daniela")

screen replay_daniela_04:
    hbox:
        xpos 960
        ypos 320
        imagebutton auto "replaydonna03_%s.png" focus_mask True action Jump("replay_v7_dand_thresome")

screen replay_mary_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaymary01_%s.png" focus_mask True action Jump("replay_v2_home_mary")

screen replay_mary_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaymary02_%s.png" focus_mask True action Jump("replay_v3_peep_mary")

screen replay_mary_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaymary03_%s.png" focus_mask True action Jump("replay_v5_peep_mary")

screen replay_mary_04:
    hbox:
        xpos 960
        ypos 320
        imagebutton auto "replaymary04_%s.png" focus_mask True action Jump("replay_v6_hospital_mary")

screen replay_mary_05:
    hbox:
        xpos 1050
        ypos 320
        imagebutton auto "replaymary05_%s.png" focus_mask True action Jump("replay_v6_room_mary")

screen replay_mary_06:
    hbox:
        xpos 1140
        ypos 320
        imagebutton auto "replaymary06_%s.png" focus_mask True action Jump("replay_v8_mary_sex")

screen replay_bandm_m_01:
    hbox:
        xpos 960
        ypos 410
        imagebutton auto "replaybandm01_%s.png" focus_mask True action Jump("replay_v9_bandm_sex")


screen replay_barbara_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaybarbara01_%s.png" focus_mask True action Jump("replay_v2_peep_barbara")

screen replay_barbara_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaybarbara02_%s.png" focus_mask True action Jump("replay_v4_barbara_sex")

screen replay_barbara_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaybarbara03_%s.png" focus_mask True action Jump("replay_v7_barbara_sex")

screen replay_barbara_04:
    hbox:
        xpos 960
        ypos 320
        imagebutton auto "replaybarbara04_%s.png" focus_mask True action Jump("replay_v9_barbara_sex")

screen replay_bandm_b_01:
    hbox:
        xpos 1050
        ypos 320
        imagebutton auto "replaybandm01_%s.png" focus_mask True action Jump("replay_v9_bandm_sex")

screen replay_sofia_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaysofia01_%s.png" focus_mask True action Jump("replay_v3_peep01_sofia")

screen replay_julia_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replayjulia01_%s.png" focus_mask True action Jump("replay_v3_peep_julia")

screen replay_julia_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replayjulia02_%s.png" focus_mask True action Jump("replay_v6_peep_julia")

screen replay_julia_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replayjulia03_%s.png" focus_mask True action Jump("replay_v6_bj_julia")

screen replay_julia_04:
    hbox:
        xpos 960
        ypos 320
        imagebutton auto "replayjulia04_%s.png" focus_mask True action Jump("replay_v9_julia_sex")

screen replay_bella_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaybella01_%s.png" focus_mask True action Jump("replay_v5_bella_sex")

screen replay_bella_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaybella02_%s.png" focus_mask True action Jump("replay_v6_bella_sex")

screen replay_bella_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaybella03_%s.png" focus_mask True action Jump("replay_v10_bella_sex")


screen replay_sofia_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaysofia02_%s.png" focus_mask True action Jump("replay_v3_peep02_sofia")

screen replay_sofia_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaysofia03_%s.png" focus_mask True action Jump("replay_v10_sofia_sex")

screen replay_jane_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replayjane02_%s.png" focus_mask True action Jump("replay_v2_home_jane")

screen replay_angela_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replayangela02_%s.png" focus_mask True action Jump("replay_v3_appartment_angela")


screen replay_angela_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replayangela03_%s.png" focus_mask True action Jump("replay_v5_anal_angela")


screen replay_jane_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replayjane03_%s.png" focus_mask True action Jump("replay_v3_appartment_jane")

screen replay_threesome_j_01:
    hbox:
        xpos 960
        ypos 320
        imagebutton auto "replaythreesome01_%s.png" focus_mask True action Jump("replay_v3_threesome_jane")

screen replay_threesome_d_01:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaythreesome01_%s.png" focus_mask True action Jump("replay_v3_threesome_daniela")

screen replay_donna_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaydonna01_%s.png" focus_mask True action Jump("replay_v4_donna_bj")

screen replay_donna_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaydonna02_%s.png" focus_mask True action Jump("replay_v5_donna_sex")

screen replay_donna_03:
    hbox:
        xpos 1140
        ypos 230
        imagebutton auto "replaydonna03_%s.png" focus_mask True action Jump("replay_v7_dand_thresome")


screen replay_marcy_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replaymarcy01_%s.png" focus_mask True action Jump("replay_v4_marcy_sex")

screen replay_marcy_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replaymarcy02_%s.png" focus_mask True action Jump("replay_v8_marcy_sex")

screen replay_elena_01:
    hbox:
        xpos 960
        ypos 230
        imagebutton auto "replayelena01_%s.png" focus_mask True action Jump("replay_v7_elena_bj")

screen replay_elena_02:
    hbox:
        xpos 1050
        ypos 230
        imagebutton auto "replayelena02_%s.png" focus_mask True action Jump("replay_v9_elena_sex")

##### BOARD ###############
label storyboard:
    scene bg_board

    hide screen board_newmale
    hide screen board_newfemale

    ### HIDE BOARD BIO SRCEENS ###
    $ clear_bio_screens()
    ## END HIDE BIO BOARD SCREENS ###

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    ### HIDE STORE SRCEENS ###
    $ clear_store_screens()
    ## END HIDE REPLAY SCREENS ###

    #RESET BOARD #
    $ clear_front_screens()

    show screen board_continue

    if storytracker < 34:
        show screen board_control
    elif storytracker >= 34 and storytracker <= 40:
        show screen board_control34
    if storytracker > 40:
        if city_control_g == 7 and city_control_t == 1 and city_control_f == 2:
            show screen board_control712
        elif city_control_g == 6 and city_control_t == 3 and city_control_f == 1:
            show screen board_control631
        elif city_control_g == 6 and city_control_t == 2 and city_control_f == 2:
            show screen board_control622
        elif city_control_g == 5 and city_control_t == 3 and city_control_f == 2:
            show screen board_control532
        elif city_control_g == 3 and city_control_t == 4 and city_control_f == 3:
            show screen board_control343
        elif city_control_g == 5 and city_control_t == 2 and city_control_f == 3:
            show screen board_control523
        elif city_control_g == 4 and city_control_t == 4 and city_control_f == 2:
            show screen board_control442
        elif city_control_g == 3 and city_control_t == 5 and city_control_f == 2:
            show screen board_control352
        elif city_control_g == 2 and city_control_t == 6 and city_control_f == 2:
            show screen board_control262
        elif city_control_g == 1 and city_control_t == 8 and city_control_f == 1:
            show screen board_control262
        elif city_control_g == 5 and city_control_t == 5 and city_control_f == 0:
            show screen board_control550
        elif storytracker > 51:
            show screen board_control442
        else:
            show screen board_control34

    # show screen city_control_meter

    show screen board_main
    show screen board_ang
    show screen board_jane

    if storytracker == 9 and not paulieset and not persistent.mods_installed:
        show screen board_newmale

    if storytracker >= 12:
        show screen board_paulie
        show screen board_mary
        show screen board_frank
        show screen board_sofia

    if storytracker == 16 and not danielaset and not persistent.mods_installed:
        show screen board_newfemale

    if storytracker >= 19:
        show screen board_daniela

    if storytracker == 22 and not barbaraset and not persistent.mods_installed:
        show screen board_newfemale

    if storytracker > 23:
        show screen board_barbara

    if storytracker >= 26:
        show screen board_donna
        show screen board_marcy

    if storytracker >= 27:
        show screen board_julia

    if storytracker == 34 and not salset:
        show screen board_newmale

    if storytracker >= 35:
        show screen board_sal

    if storytracker >= 36:
        if not bellaset:
            show screen board_newfemale
        show screen board_donf

    if storytracker >= 37:
        show screen board_bella

    if storytracker >= 42:
        show screen board_shop

    if storytracker >= 52:
        show screen board_elena

    if storytracker >= 61:
        hide screen board_elena
        show screen board_elena2

    $character_bio = "none"

    $renpy.pause(hard=True)
    "..."
    jump storyboard

#### BIOS ###########
    ## UNKNOWN CHARACTER ##
label bio_newchar:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    if storytracker == 9:
        $character_bio = p
        scene intro_relation_p
        jump reset_character

    if storytracker == 16:
        $character_bio = d
        scene intro_relation_d
        jump reset_character

    if storytracker == 22:
        $character_bio = b
        scene intro_relation_b
        jump reset_character

    if storytracker == 34:
        $character_bio = sal
        scene intro_relation_sal
        jump reset_character

    if storytracker == 36:
        $character_bio = bella
        scene intro_relation_bella
        jump reset_character

    $renpy.pause(hard=True)
    "..."
    jump bio_newchar


    ## MAIN ##
label bio_main:
    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $character_bio = y
    if storytracker >= 42:
        scene bg_biomain42
        show screen mymoney
    else:
        scene bg_biomain:

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_y_details_001
    show screen bio_character_leader
    show screen bio_character_ruthless
    ## show screen fullhistory # for chap 8

    $renpy.pause(hard=True)
    "..."
    jump bio_main

#/*************************************************NEXT CHAR MARY
### Mary ####
label bio_mary:
    $character_bio = m
    scene bg_biomary

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(mary_relation)
    $ relationship_points = mary_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_m_details_001

    if maryscene01 or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_mary_01

    if maryscene02 or persistent.unlocked:
        show screen replay_mary_02
    elif storytracker > 38:
        show screen replay_02_lock

    if v5_mary_replay or persistent.unlocked:
        show screen replay_mary_03
    elif storytracker > 46:
        show screen replay_03_lock

    if v5_mary_replay or persistent.unlocked:
        show screen replay_mary_03
    elif storytracker > 46:
        show screen replay_04_lock

    if v6_mary_hospital_sex_replay or persistent.unlocked:
        show screen replay_mary_04
    elif storytracker > 49:
        show screen replay_04_lock

    if v6_mary_room_replay or persistent.unlocked:
        show screen replay_mary_05
    elif storytracker > 49:
        show screen replay_05_lock

    if v8_replay_mary_sex or persistent.unlocked:
        show screen replay_mary_06
    elif storytracker > 55:
        show screen replay_06_lock

    if v9_sex_bandm_replay or persistent.unlocked:
        show screen replay_bandm_m_01
    elif storytracker > 60:
        show screen replay_07_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_mary

#######MARY REPLAY ####
label replay_v2_home_mary:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v2_replay_mary_01

label replay_v3_peep_mary:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_mary_peep_replay

label replay_v5_peep_mary:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v5_mary_peeping

label replay_v6_hospital_mary:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v6_mary_hospital_sex


label replay_v6_room_mary:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v6_mary_afterdate

label replay_v8_mary_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v8_replay_mary_sex

label replay_v9_bandm_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v9_replay_bandm_sex



#/*************************************************NEXT CHAR FRANK
### Frank ####
label bio_frank:
    $character_bio = f
    scene bg_biofrank

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_f_details_001

    $renpy.pause(hard=True)
    "..."
    jump bio_frank

#/*************************************************NEXT CHAR SOFIA
### Sofia ####
label bio_sofia:
    $character_bio = s
    scene bg_biosofia

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(sofia_relation)
    $ relationship_points = sofia_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_s_details_001


    if sofiascene01 or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_sofia_01
    elif storytracker > 38:
        show screen bio_replay_text
        show screen replay_01_lock

    if sofiascene02 or persistent.unlocked:
        show screen replay_sofia_02
    elif storytracker > 38:
        show screen replay_02_lock

    if v10_replaysofiasex or persistent.unlocked:
        show screen replay_sofia_03
    elif storytracker > 62:
        show screen replay_03_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_sofia

label replay_v3_peep01_sofia:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_sofia_peep01_replay

label replay_v3_peep02_sofia:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_sofia_peep02_replay

#/*************************************************NEXT CHAR PAULIE

### PAULIE ####
label bio_paulie:
    $character_bio = p
    scene bg_biopaulie:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_p_details_001

    $renpy.pause(hard=True)
    "..."
    jump bio_paulie

#/*************************************************NEXT CHAR BARBARA
### BARBARA ####
label bio_barbara:
    $character_bio = b
    scene bg_biobarbara:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(barbara_relation)
    $ relationship_points = barbara_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_b_details_001

    if barbarascene01 or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_barbara_01
    elif storytracker >= 34:
        show screen bio_replay_text
        show screen replay_01_lock

    if barbarascene02 or persistent.unlocked:
        show screen replay_barbara_02
    elif storytracker >= 42:
        show screen replay_02_lock

    if v7_barbarasex_replay or persistent.unlocked:
        show screen replay_barbara_03
    elif storytracker >= 55:
        show screen replay_03_lock

    if v9_sex_barbara_replay or persistent.unlocked:
        show screen replay_barbara_04
    elif storytracker >= 61:
        show screen replay_04_lock

    if v9_sex_bandm_replay or persistent.unlocked:
        show screen replay_bandm_b_01
    elif storytracker > 60:
        show screen replay_05_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_barbara

#######BARBARA REPLAY ####
label replay_v2_peep_barbara:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v2_main_home_03

label replay_v4_barbara_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump replay_v4_barbara02

label replay_v7_barbara_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v7_barbara_sex_replay

label replay_v9_barbara_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v9_barbara_sex_replay

#/*************************************************NEXT CHAR ANGELA
    ##ANGELA ##
label bio_ang:
    $character_bio = ang
    scene bg_bioangela:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(angela_relation)
    $ relationship_points = angela_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_ang_details_001
    show screen bio_replay_text

    if angelascene01 or persistent.unlocked:
        show screen replay_angela_01
    else:
        show screen replay_01_lock

    if angelascene02 or persistent.unlocked:
        show screen replay_angela_02
    elif storytracker > 37:
        show screen replay_02_lock

    if v5_angela_sex or persistent.unlocked:
        show screen replay_angela_03
    elif storytracker > 46:
        show screen replay_03_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_ang

####### ANGELA REPLAY ####
label replay_v1_appartment_angela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v1_appartment_angela

label replay_v3_appartment_angela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_angela_replay

label replay_v5_anal_angela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v5_angela_sex

#/*************************************************NEXT CHAR JANE
    ##JANE ##
label bio_cof:
    $character_bio = cof
    scene bg_biojane:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(jane_relation)
    $ relationship_points = jane_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_cof_details_001

    if janescene01 == True or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_jane_01
    else:
        show screen bio_replay_text
        show screen replay_01_lock

    if v2_janescene02 == True or persistent.unlocked:
        show screen replay_jane_02

    if janescene03 == True or persistent.unlocked:
        show screen replay_jane_03
    elif storytracker > 40:
        show screen replay_03_lock

    if threesome01 == True or persistent.unlocked:
        show screen replay_threesome_j_01
    elif storytracker > 40:
        show screen replay_04_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_cof

#######JANE REPLAY ####
label replay_v1_appartment_jane:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v1_appartment_jane

label replay_v2_home_jane:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v2_home_jane01_continue

label replay_v3_appartment_jane:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_jane03_replay

label replay_v3_threesome_jane:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_threesome_replay

#/*************************************************NEXT CHAR DANIELLA
    ##DANIELA ##
label bio_daniela:
    $character_bio = d
    scene bg_biodaniela:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(daniela_relation)
    $ relationship_points = daniela_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_d_details_001

    if danielascene01 == True or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_daniela_01

    if threesome01 == True or persistent.unlocked:
        show screen replay_threesome_d_01
    elif storytracker >= 41:
        show screen replay_02_lock

    if v6_daniela_sex_replay or persistent.unlocked:
        show screen replay_daniela_02
    elif storytracker > 47:
        show screen replay_03_lock

    if v7_dand_threesome or persistent.unlocked:
        show screen replay_daniela_04
    elif storytracker > 52:
        show screen replay_04_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_daniela

#######DANIELA REPLAY ####
label replay_v1_home_daniela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v1_home_d002

label replay_v3_threesome_daniela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_threesome_replay


label replay_v6_barsex_daniela:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v6_daniela_sex


#/*************************************************NEXT CHAR JULIA
    ##JULIA ##
label bio_julia:
    $character_bio = j
    scene bg_biojulia:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(julia_relation)
    $ relationship_points = julia_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_j_details_001

    if juliascene01 or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_julia_01
    elif storytracker > 39:
        show screen bio_replay_text
        show screen replay_01_lock

    if v6_julia_shop_replay or persistent.unlocked:
        show screen replay_julia_02
    elif storytracker > 50:
        show screen replay_02_lock

    if v6_julia_bj_replay or persistent.unlocked:
        show screen replay_julia_03
    elif storytracker > 50:
        show screen replay_03_lock

    if v9_sex_julia_replay or persistent.unlocked:
        show screen replay_julia_04
    elif storytracker > 60:
        show screen replay_04_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_julia

#######JULIA REPLAY ####
label replay_v3_peep_julia:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v3_julia_shower01


label replay_v6_peep_julia:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v6_julia_shop_replay

label replay_v6_bj_julia:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v6_julia_bj_replay

label replay_v9_julia_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v9_julia_sex_replay

#/*************************************************NEXT CHAR DET
    ##MARCY ##
label bio_marcy:
    $character_bio = det
    scene bg_biomarcy:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(marcy_relation)
    $ relationship_points = marcy_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_cop_details_001

    if marcyscene01 and gambling or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_marcy_01
    else:
        if storytracker > 43:
            show screen bio_replay_text
            show screen replay_01_lock

    if v8_replay_marcy_sex or persistent.unlocked:
        show screen replay_marcy_02
    elif storytracker > 57:
        show screen replay_02_lock


    $renpy.pause(hard=True)
    "..."
    jump bio_marcy

#######MARCY REPLAY ####
label replay_v4_marcy_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v4_marcy01_replay

label replay_v8_marcy_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v8_replay_marcy_sex

#/*************************************************NEXT CHAR DONNA
    ##DONNA ##
label bio_donna:
    $character_bio = don
    scene bg_biodonna:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(donna_relation)
    $ relationship_points = donna_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_donna_details_001

    if donnascene01 and v4_donna_dance or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_donna_01
    elif storytracker > 42:
        show screen bio_replay_text
        show screen replay_01_lock

    if v5_donna_sex or persistent.unlocked:
        show screen replay_donna_02
    elif storytracker > 45:
        show screen replay_02_lock

    if v7_dand_threesome or persistent.unlocked:
        show screen replay_donna_03
    elif storytracker > 52:
        show screen replay_03_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_donna

#######DONNAREPLAY ####
label replay_v4_donna_bj:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v4_donna01_replay

label replay_v5_donna_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v5_donna_sex

label replay_v7_dand_thresome:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v7_dand_threesome_replay
#/*************************************************NEXT CHAR SAL
    ##SAL ##
label bio_sal:
    $character_bio = sal
    scene bg_biosal:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_sal_details_001

    $renpy.pause(hard=True)
    "..."
    jump bio_sal

#/*************************************************NEXT CHAR DONF
    ##DON FARENZA ##
label bio_donf:
    $character_bio = donf
    scene bg_biodonf:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_donf_details_001

    $renpy.pause(hard=True)
    "..."
    jump bio_donf

#/*************************************************NEXT CHAR BELLA
    ##BELLA ##
label bio_bella:
    $character_bio = bella
    scene bg_biobella:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(bella_relation)
    $ relationship_points = bella_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_bella_details_001

    if v5_bella_sex or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_bella_01
    elif storytracker > 46:
        show screen bio_replay_text
        show screen replay_01_lock

    if v6_bella_sex_replay or persistent.unlocked:
        show screen replay_bella_02
    elif storytracker >= 49:
        show screen replay_02_lock

    if v10_replaybellasex or persistent.unlocked:
        show screen replay_bella_03
    elif storytracker > 61:
        show screen replay_03_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_bella

####### BELLA REPLAY ####
label replay_v5_bella_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v5_bellamc_sex

label replay_v6_bella_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###
    if v6_bella_hard:
        jump v6_bella_sex_aggressive
    else:
        jump v6_bella_sex_vanilla

label replay_v10_bella_sex:
    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###
    jump v10_bella_sex



#/*************************************************NEXT CHAR ELENA
    ##ELENA ##
label bio_elena:
    $character_bio = e
    if storytracker >= 61:
        scene bg_bioelena02:
    else:
        scene bg_bioelena:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    $ relationship_status = set_relationship_status(elena_relation)
    $ relationship_points = elena_relation_meter

    show screen bio_back
    show screen bio_reset
    show screen bio_character_name
    show screen bio_character_status
    show screen bio_character_points
    show screen bio_e_details_001

    if v7_elena_replay_bj or persistent.unlocked:
        show screen bio_replay_text
        show screen replay_elena_01
    elif storytracker > 53:
        show screen bio_replay_text
        show screen replay_01_lock

    if v9_sex_emma_replay or persistent.unlocked:
        show screen replay_elena_02
    elif storytracker >= 60:
        show screen replay_02_lock

    $renpy.pause(hard=True)
    "..."
    jump bio_elena

####### elena REPLAY ####
label replay_v7_elena_bj:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v7_elena_bj

label replay_v9_elena_sex:

    ### HIDE REPLAY SRCEENS ###
    $ clear_replay_screens()
    ## END HIDE REPLAY SCREENS ###

    jump v9_elena_replaysex

#### RESET ##############
label reset_character:
    hide screen bio_back
    hide screen bio_reset
    hide screen bio_character_name

    ## MAIN ##
    if character_bio == y:
        $ ytemp = renpy.input("This is you. What is your name?", length=11)
        $ ytemp = ytemp.strip()
        if ytemp == "":
            $ ytemp = "Vincent"
        $ y = Character(ytemp, color="#ff0000", image="main_badge")
        menu:
            y "Hi, my name is [y]."
            "Yes.":
                jump bio_main
            "No, let me change it.":
                $ character_bio = y
                jump reset_character

    ## ANGELA ##
    if character_bio == ang:
        $ angtemp = renpy.input("This is [ang]. What is her new name?", length=11)
        $ angtemp = angtemp.strip()
        if angtemp == "":
            $ angtemp = "Angela"
        $ ang = Character(angtemp, color="#f7528e", image="angela_badge")
        $ angr = renpy.input("You are her: (default: Friend)")
        $ angr = angr.strip()
        if angr == "":
           $ angr = "Friend"
        menu:
            ang "Hello, my name is [ang]. I am your [angr]"
            "Yes.":
                jump bio_ang
            "No, let me change it.":
                $ character_bio = ang
                jump reset_character

    ## Jane ##
    if character_bio == cof:
        $ coftemp = renpy.input("This is [cof]. What is her new name?", length=11)
        $ coftemp = coftemp.strip()
        if coftemp == "":
            $ coftemp = "Jane"
        $ cof = Character(coftemp, color="#99dade", image="jane_badge")
        $ cofr = renpy.input("You are her: (default: Friend)")
        $ cofr = cofr.strip()
        if cofr == "":
           $ cofr = "Friend"
        menu:
            cof "Hello, my name is [cof]. I am your [cofr]"
            "Yes.":
                jump bio_cof
            "No, let me change it.":
                $ character_bio = cof
                jump reset_character

    ## Paulie ##
    if character_bio == p:
        $ ptemp = renpy.input("This is [p]. What is his new name?", length=11)
        $ ptemp = ptemp.strip()
        if ptemp == "":
            $ ptemp = "Paulie"
        $ p = Character(ptemp, color="#03820f", image="paulie_badge")
        $ pr = renpy.input("This is [p] Gallio. He is [f] Gallio's brother. He is your: (default: Supervisor)")
        $ pr = pr.strip()
        if pr == "":
           $ pr = "Supervisor"
        $ yp = renpy.input("That means you are his: (default: Employee)")
        $ yp = yp.strip()
        if yp == "":
           $ yp = "Employee"
        $ py = renpy.input("Usually you call him: (default: Supervisor)")
        $ py = py.strip()
        if py == "":
           $ py = "Supervisor"
        menu:
            p "Hi [y]! I'm so glad to see you! You are my [yp!l] and I am your [pr!l]. You call me [py] [p].\nDoes this sentence make sense?"
            "Yes.":
                if storytracker == 9:
                    $paulieset = True
                    jump storyboard
                else:
                    jump bio_paulie
            "No, let me change it.":
                $ character_bio = p
                jump reset_character


    ## Mary ##
    if character_bio == m:
        $ mtemp = renpy.input("This is [m]. What is her new name?", length=11)
        $ mtemp = mtemp.strip()
        if mtemp == "":
            $ mtemp = "Mary"
        $ m = Character(mtemp, color="#f21dd2", image="mary_badge") #pink
        $ mr = renpy.input("This is [m] Gallio. You live in the same house. She is your: (default: Teacher)")
        $ mr = mr.strip()
        if mr == "":
           $ mr = "Teacher"
        $ ym = renpy.input("That means you are her: (default: Student)")
        $ ym = ym.strip()
        if ym == "":
           $ ym = "Student"
        $ my = renpy.input("Usually you call her: (default: Miss Gallio)")
        $ my = my.strip()
        if my == "":
           $ my = "Miss Gallio"
        menu:
            m "Hi [y]! I'm so glad to see you! You are my [ym!l] and I am your [mr!l]. You call me [my!l].\nDoes this sentence make sense?"
            "Yes, this makes sense.":
                jump storyboard
            "No, let me change it.":
                $ character_bio = m
                jump reset_character


    ## frank ##
    if character_bio == f:
        $ ftemp = renpy.input("This is [f]. What is his new name?", length=11)
        $ ftemp = ftemp.strip()
        if ftemp == "":
            $ ftemp = "Frank"
        $ f = Character(ftemp, color="#00b4f0", image="frank_badge")
        $ fr = renpy.input("This is [f] \"two gun\" Gallio. You live in the same house. He is your: (default: Mentor)")
        $ fr = fr.strip()
        if fr == "":
           $ fr = "Mentor"
        $ yf = renpy.input("That means you are his: (default: Protégé)")
        $ yf = yf.strip()
        if yf == "":
           $ yf = "Protégé"
        $ fy = renpy.input("Usually you call him: (default: Boss)")
        $ fy = fy.strip()
        if fy == "":
           $ fy = "Boss"
        menu:
            f "Hi [y]! I'm so glad to see you! You are my [yf!l] and I am your [fr!l]. You call me [fy!l].\nDoes this sentence make sense?"
            "Yes, this makes sense.":
                jump storyboard
            "No, let me change it.":
                $ character_bio = f
                jump reset_character


    ## Sofia ##
    if character_bio == s:
        $ stemp = renpy.input("This is [s]. What is her new name?", length=11)
        $ stemp = stemp.strip()
        if stemp == "":
            $ stemp = "Sofia"
        $ s = Character(stemp, color="#ff9933", image="tina_badge")
        $ sr = renpy.input("This is [s]. You live in the same house. She is your: (default: Friend)")
        $ sr = sr.strip()
        if sr == "":
           $ sr = "Friend"
        $ ys = renpy.input("That means you are her: (default: Friend)")
        $ ys = ys.strip()
        if ys == "":
           $ ys = "Friend"
        menu:
            s "Hi [y]! I'm so glad to see you! You are my [ys!l] and I am your [sr!l]. \nDoes this sentence make sense?"
            "Yes, this makes sense.":
                jump storyboard
            "No, let me change it.":
                $ character_bio = s
                jump reset_character


    ## Daniela ##
    if character_bio == d:
        $ dtemp = renpy.input("This is [d]. What is her new name?", length=11)
        $ dtemp = dtemp.strip()
        if dtemp == "":
            $ dtemp = "Daniela"
        $ d = Character(dtemp, color="#ff9933", image="daniela_badge")
        $ dr = renpy.input("This is [d]. She is the daughter of [p] your [pr!l]. She is your: (default: Friend)")
        $ dr = dr.strip()
        if dr == "":
           $ dr = "Friend"
        $ yd = renpy.input("That means you are her: (default: Friend)")
        $ yd = yd.strip()
        if yd == "":
           $ yd = "Friend"
        menu:
            d "Hi [y]! I'm so glad to see you! You are my [yd!l] and I am your [dr!l]. \nDoes this sentence make sense?"
            "Yes, this makes sense.":
                $ danielaset = True
                jump storyboard
            "No, let me change it.":
                $ character_bio = d
                jump reset_character

    ## Julia ##
    if character_bio == j:
        if v2_reset_julia:
            menu:
                "Set character and relation or use defaults?"
                "Use defaults":
                    $v2_reset_julia = False
                    $ juliaset = True
                    $ clear_bio_screens()
                    $ clear_replay_screens()
                    jump v2_home_start
                "Set character and relation":
                    pass

        $ jtemp = renpy.input("This is [j]. What is her new name?", length=11)
        $ jtemp = jtemp.strip()
        if jtemp == "":
            $ jtemp = "Julia"
        $ j = Character(jtemp, color="#ff9933", image="julia_badge")
        $ jr = renpy.input("This is [j]. She is the daughter of [p] your [pr!l]. She is your: (default: Friend)")
        $ jr = jr.strip()
        if jr == "":
           $ jr = "Friend"
        $ yj = renpy.input("That means you are her: (default: Friend)")
        $ yj = yj.strip()
        if yj == "":
           $ yj = "Friend"
        menu:
            j "Hi [y]! I'm so glad to see you! You are my [yj!l] and I am your [jr!l]. \nDoes this sentence make sense?"
            "Yes, this makes sense.":
                $ juliaset = True
                if v2_reset_julia:
                    $v2_reset_julia = False
                    $ clear_bio_screens()
                    $ clear_replay_screens()
                    jump v2_home_start
                jump storyboard
            "No, let me change it.":
                $ character_bio = j
                jump reset_character

    ## Barbara ##
    if character_bio == b:
        $ btemp = renpy.input("This is [b]. What is her new name?", length=11)
        $ btemp = btemp.strip()
        if btemp == "":
            $ btemp = "Barbara"
        $ b = Character(btemp, color="#ff9933", image="barbara_badge")
        $ br = renpy.input("This is [b]. She is the wife of [p] your [pr!l]. She is your: (default: Supervisor's wife)")
        $ br = br.strip()
        if br == "":
           $ br = "Supervisor's wife"
        $ yb = renpy.input("That means you are her: (default: Friend)")
        $ yb = yb.strip()
        if yb == "":
           $ yb = "Friend"
        $ by = renpy.input("Usually you call her: (default: Miss)")
        $ by = by.strip()
        if by == "":
           $ by = "Miss"
        menu:
            b "Hi [y]! I'm so glad to see you! You are my [yb!l] and I am your [br!l]. Usually you call me [by] [b] \nDoes this sentence make sense?"
            "Yes, this makes sense.":
                $ barbaraset = True
                jump storyboard
            "No, let me change it.":
                $ character_bio = b
                jump reset_character

    ## donna ##
    if character_bio == don:
        $ dontemp = renpy.input("This is [don]. What is her new name?", length=11)
        $ dontemp = dontemp.strip()
        if dontemp == "":
            $ dontemp = "Donna"
        $ don = Character(dontemp, color="#5bb6bd", image="donna_badge")
        $ donr = renpy.input("She is your: (default: Friend)")
        $ donr = donr.strip()
        if donr == "":
           $ donr = "Friend"
        menu:
            don "My name is [don]. I am your [donr]."
            "Yes, this makes sense.":
                jump storyboard
            "No, let me change it.":
                $ character_bio = don
                jump reset_character

    ## marcy ##
    if character_bio == det:
        $ dettemp = renpy.input("This is [det]. What is her new name?", length=11)
        $ dettemp = dettemp.strip()
        if dettemp == "":
            $ dettemp = "Marcy"
        $ det = Character(dettemp, color="#5bb6bd", image="marcy_badge")
        $ detr = renpy.input("She is your: (default: Friend/Enemy)")
        $ detr = detr.strip()
        if detr == "":
            if drugs:
                $ detr = "Enemy"
            else:
                $ detr = "Friend"
        menu:
            det "My name is [det]. I am your [detr]."
            "Yes, this makes sense.":
                jump storyboard
            "No, let me change it.":
                $ character_bio = det
                jump reset_character

    ## Sal ##
    if character_bio == sal:
        $ saltemp = renpy.input("This is [sal]. What is his new name?", length=11)
        $ saltemp = saltemp.strip()
        if saltemp == "":
            $ saltemp = "Sal"
        $ sal = Character(saltemp, color="#5bb6bd", image="sal_badge")
        $ salr = renpy.input("He is your: (default: Enemy)")
        $ salr = salr.strip()
        if salr == "":
           $ salr = "Enemy"
        menu:
            sal "My name is [sal]. I am your [salr]"
            "Yes, this makes sense.":
                $ salset = True
                jump storyboard
            "No, let me change it.":
                $ character_bio = sal
                jump reset_character


    ## don farenza ##
    if character_bio == donf:
        $ donftemp = renpy.input("This is [donf]. What is his new name?", length=11)
        $ donftemp = donftemp.strip()
        if donftemp == "":
            $ donftemp = "Tommy"
        $ donf = Character(donftemp, color="#ff66cc", image="donf_badge")
        $ donfr = renpy.input("He is your: (default: Friend)")
        $ donfr = donfr.strip()
        if donfr == "":
           $ donfr = "Friend"
        menu:
            donf "My name is [donf]. I am your [donfr]."
            "Yes, this makes sense.":
                $ donfset = True
                jump storyboard
            "No, let me change it.":
                $ character_bio = donf
                jump reset_character

    ## bella ##
    if character_bio == bella:
        $ bellatemp = renpy.input("This is [bella]. What is her new name?", length=11)
        $ bellatemp = bellatemp.strip()
        if bellatemp == "":
            $ bellatemp = "Bella"
        $ bella = Character(bellatemp, color="#ff66dd", image="bella_badge")
        $ bellar = renpy.input("She is your: (default: Friend)")
        $ bellar = bellar.strip()
        if bellar == "":
           $ bellar = "Friend"
        menu:
            bella "My name is [bella]. I am your [bellar]."
            "Yes, this makes sense.":
                $ bellaset = True
                jump storyboard
            "No, let me change it.":
                $ character_bio = bella
                jump reset_character


    ## elena ##
    if character_bio == e:
        $ etemp = renpy.input("This is [e]. What is her new name?", length=11)
        $ etemp = etemp.strip()
        if etemp == "":
            $ etemp = "Emma"
        $ e = Character(etemp, color="#ff66dd", image="elena_badge")
        $ er = renpy.input("She is your: (default: Friend)")
        $ er = er.strip()
        if er == "":
           $ er = "Friend"
        menu:
            e "My name is [e]. I am your [er]."
            "Yes, this makes sense.":
                $ elenaset = True
                if storytracker == 51:
                    jump v7_endchapsix
                else:
                    jump storyboard
            "No, let me change it.":
                $ character_bio = e
                jump reset_character

    $renpy.pause(hard=True)
    "..."
    jump reset_character

#### CONTINUE ##########
label story_continues:

    ### HIDE BOARD SRCEENS ###
    $ clear_front_screens()
    ## END HIDE BOARD SCREENS ###

    if storytracker == 9:
        if not paulieset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $paulieset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v1_home_m001

    if storytracker == 12:
        jump v1_car_p001

    if storytracker == 16:
        if not danielaset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $danielaset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v1_home_m002

    if storytracker == 19:
        jump v2_start

    if storytracker == 20:
        jump v2_home_start

    if storytracker == 22:
        if not barbaraset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $barbaraset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v2_kitchen_01

    if storytracker == 24:
        if not juliaset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $juliaset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v2_bar_01


    if storytracker == 26:
        jump v2_main_home_02

    if storytracker == 34:
        if not salset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $salset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v2_car_001

    if storytracker == 35:
        jump v3_start

    if storytracker == 36:
        if not bellaset:
            menu:
                "There are characters that have not been customized yet, are you sure you want to continue?"
                "Use defaults.":
                    $bellaset = True
                    pass
                "Go back and customize.":
                    jump storyboard
        jump v3_home_choice_01

    if storytracker == 37:
        jump v3_home_office02

    if storytracker == 38:
        jump v3_after_sal_home

    if storytracker == 39:
        jump v3_barbara_home01

    if storytracker == 40:
        jump v3_daniela_bar

    if storytracker == 41:
        jump v4_start

    if storytracker == 42:
        jump v4_home_supper

    if storytracker == 43:
        jump v4_bella

    if storytracker == 44:
        jump v5_start

    if storytracker == 45:
        jump v5_royal_mario

    if storytracker == 46:
        jump v5_angela_home

    if storytracker == 47:
        if v5_bella_sex:
            $ bella_relation = 2
        jump v6_start

    if storytracker == 48:
        jump v6_bella_presex

    if storytracker == 49:
        jump v6_mary_pre_date

    if storytracker == 50:
        jump v6_julia_text

    if storytracker == 51:
        jump v7_start

    if storytracker == 52:
        jump v7_home_afterbod_01

    if storytracker == 53:
        jump v7_sofia_park

    if storytracker == 54:
        jump v7_inroom

    if storytracker == 55:
        jump v8_start

    if storytracker == 56:
        jump v8_flashback_hospital02

    if storytracker == 57:
        jump v8_prejane

    if storytracker == 58:
        jump v9_start

    if storytracker == 59:
        jump v9_hospital01

    if storytracker == 60:
        jump v9_pre_barb

    if storytracker == 61:
        jump v10_start

    if storytracker == 62:
        jump v10_sofia

    if storytracker == 63:
        jump v10_funeral_bella

label endchapter:
    scene black
    scene halloffame with Dissolve(2.0)
    hide window
    $renpy.pause()

    scene thankyouscreen with Dissolve(1.0)
    if v10_jane_faithful:
        "{b}Alternate ending.{/b} To view the offcial ending, let [cof] leave Dover city (chapter 8).\nYou reached the end of part 1. Want more?\nCheck {a=https://www.patreon.com/hsagames}https://www.patreon.com/hsagames{/a} for news on part 2."
    else:
        "{b}THE END{/b}. You reached the end of part 1. Want more? \n Check {a=https://www.patreon.com/hsagames}https://www.patreon.com/hsagames{/a} for news on part 2."
    jump storyboard
